// -------------------------------------------------- //
// This file is autogenerated by pioasm; do not edit! //
// -------------------------------------------------- //

#pragma once

#if !PICO_NO_HARDWARE
#include "hardware/pio.h"
#endif

// ----------- //
// pio_encoder //
// ----------- //

#define pio_encoder_wrap_target 0
#define pio_encoder_wrap 12

static const uint16_t pio_encoder_program_instructions[] = {
            //     .wrap_target
    0xe020, //  0: set    x, 0                       
    0xe040, //  1: set    y, 0                       
    0xc040, //  2: irq    clear 0                    
    0xa0c1, //  3: mov    isr, x                     
    0xa0c3, //  4: mov    isr, null                  
    0x4002, //  5: in     pins, 2                    
    0xa026, //  6: mov    x, isr                     
    0x00a9, //  7: jmp    x != y, 9                  
    0x0004, //  8: jmp    4                          
    0xa041, //  9: mov    y, x                       
    0x8020, // 10: push   block                      
    0xc020, // 11: irq    wait 0                     
    0x0004, // 12: jmp    4                          
            //     .wrap
};

#if !PICO_NO_HARDWARE
static const struct pio_program pio_encoder_program = {
    .instructions = pio_encoder_program_instructions,
    .length = 13,
    .origin = -1,
};

static inline pio_sm_config pio_encoder_program_get_default_config(uint offset) {
    pio_sm_config c = pio_get_default_sm_config();
    sm_config_set_wrap(&c, offset + pio_encoder_wrap_target, offset + pio_encoder_wrap);
    return c;
}
#endif

#include "hardware/clocks.h"
#include "pico/stdlib.h"
#include "hardware/irq.h"
static inline void pio_encoder_program_init(PIO pio, uint sm, uint offset, uint pin)
{
    pio_sm_set_consecutive_pindirs(pio, sm, pin, 2, false);
    gpio_pull_down(pin);
    gpio_pull_down(pin + 1);
    pio_sm_config c = pio_encoder_program_get_default_config(offset);
    sm_config_set_jmp_pin(&c, pin);
    sm_config_set_in_pins(&c, pin);
    sm_config_set_in_shift(&c, false, false, 0);
    pio_sm_init(pio, sm, offset, &c);
    pio_sm_set_enabled(pio, sm, true);
}